
package de.bsvrz.sys.startstopp.api.jsonschema;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import com.fasterxml.jackson.annotation.JsonAnyGetter;
import com.fasterxml.jackson.annotation.JsonAnySetter;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonPropertyOrder;
import com.fasterxml.jackson.annotation.JsonValue;
import org.apache.commons.lang.builder.EqualsBuilder;
import org.apache.commons.lang.builder.HashCodeBuilder;
import org.apache.commons.lang.builder.ToStringBuilder;

@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonPropertyOrder({
    "vorgaenger",
    "warteart",
    "rechner",
    "wartezeit"
})
public class StartBedingung implements Serializable
{

    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("vorgaenger")
    private List<String> vorgaenger = new ArrayList<String>();
    @JsonProperty("warteart")
    private StartBedingung.Warteart warteart = StartBedingung.Warteart.fromValue("beginn");
    @JsonProperty("rechner")
    private String rechner;
    @JsonProperty("wartezeit")
    private String wartezeit;
    @JsonIgnore
    private Map<String, Object> additionalProperties = new HashMap<String, Object>();
    private final static long serialVersionUID = 8057706155152867328L;

    /**
     * No args constructor for use in serialization
     * 
     */
    public StartBedingung() {
    }

    /**
     * 
     * @param rechner
     * @param warteart
     * @param wartezeit
     * @param vorgaenger
     */
    public StartBedingung(List<String> vorgaenger, StartBedingung.Warteart warteart, String rechner, String wartezeit) {
        super();
        this.vorgaenger = vorgaenger;
        this.warteart = warteart;
        this.rechner = rechner;
        this.wartezeit = wartezeit;
    }

    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("vorgaenger")
    public List<String> getVorgaenger() {
        return vorgaenger;
    }

    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("vorgaenger")
    public void setVorgaenger(List<String> vorgaenger) {
        this.vorgaenger = vorgaenger;
    }

    public StartBedingung withVorgaenger(List<String> vorgaenger) {
        this.vorgaenger = vorgaenger;
        return this;
    }

    @JsonProperty("warteart")
    public StartBedingung.Warteart getWarteart() {
        return warteart;
    }

    @JsonProperty("warteart")
    public void setWarteart(StartBedingung.Warteart warteart) {
        this.warteart = warteart;
    }

    public StartBedingung withWarteart(StartBedingung.Warteart warteart) {
        this.warteart = warteart;
        return this;
    }

    @JsonProperty("rechner")
    public String getRechner() {
        return rechner;
    }

    @JsonProperty("rechner")
    public void setRechner(String rechner) {
        this.rechner = rechner;
    }

    public StartBedingung withRechner(String rechner) {
        this.rechner = rechner;
        return this;
    }

    @JsonProperty("wartezeit")
    public String getWartezeit() {
        return wartezeit;
    }

    @JsonProperty("wartezeit")
    public void setWartezeit(String wartezeit) {
        this.wartezeit = wartezeit;
    }

    public StartBedingung withWartezeit(String wartezeit) {
        this.wartezeit = wartezeit;
        return this;
    }

    @JsonAnyGetter
    public Map<String, Object> getAdditionalProperties() {
        return this.additionalProperties;
    }

    @JsonAnySetter
    public void setAdditionalProperty(String name, Object value) {
        this.additionalProperties.put(name, value);
    }

    public StartBedingung withAdditionalProperty(String name, Object value) {
        this.additionalProperties.put(name, value);
        return this;
    }

    @Override
    public String toString() {
        return new ToStringBuilder(this).append("vorgaenger", vorgaenger).append("warteart", warteart).append("rechner", rechner).append("wartezeit", wartezeit).append("additionalProperties", additionalProperties).toString();
    }

    @Override
    public int hashCode() {
        return new HashCodeBuilder().append(warteart).append(rechner).append(additionalProperties).append(wartezeit).append(vorgaenger).toHashCode();
    }

    @Override
    public boolean equals(Object other) {
        if (other == this) {
            return true;
        }
        if ((other instanceof StartBedingung) == false) {
            return false;
        }
        StartBedingung rhs = ((StartBedingung) other);
        return new EqualsBuilder().append(warteart, rhs.warteart).append(rechner, rhs.rechner).append(additionalProperties, rhs.additionalProperties).append(wartezeit, rhs.wartezeit).append(vorgaenger, rhs.vorgaenger).isEquals();
    }

    public enum Warteart {

        BEGINN("beginn"),
        ENDE("ende");
        private final String value;
        private final static Map<String, StartBedingung.Warteart> CONSTANTS = new HashMap<String, StartBedingung.Warteart>();

        static {
            for (StartBedingung.Warteart c: values()) {
                CONSTANTS.put(c.value, c);
            }
        }

        private Warteart(String value) {
            this.value = value;
        }

        @Override
        public String toString() {
            return this.value;
        }

        @JsonValue
        public String value() {
            return this.value;
        }

        @JsonCreator
        public static StartBedingung.Warteart fromValue(String value) {
            StartBedingung.Warteart constant = CONSTANTS.get(value);
            if (constant == null) {
                throw new IllegalArgumentException(value);
            } else {
                return constant;
            }
        }

    }

}
