
package de.bsvrz.sys.startstopp.api.jsonschema;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonPropertyOrder;
import org.apache.commons.lang.builder.EqualsBuilder;
import org.apache.commons.lang.builder.HashCodeBuilder;
import org.apache.commons.lang.builder.ToStringBuilder;

@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonPropertyOrder({
    "code",
    "messages"
})
public class StatusResponse implements Serializable
{

    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("code")
    private Integer code;
    @JsonProperty("messages")
    private List<String> messages = new ArrayList<String>();
    private final static long serialVersionUID = -7096404901908953923L;

    /**
     * No args constructor for use in serialization
     * 
     */
    public StatusResponse() {
    }

    /**
     * 
     * @param code
     * @param messages
     */
    public StatusResponse(Integer code, List<String> messages) {
        super();
        this.code = code;
        this.messages = messages;
    }

    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("code")
    public Integer getCode() {
        return code;
    }

    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("code")
    public void setCode(Integer code) {
        this.code = code;
    }

    public StatusResponse withCode(Integer code) {
        this.code = code;
        return this;
    }

    @JsonProperty("messages")
    public List<String> getMessages() {
        return messages;
    }

    @JsonProperty("messages")
    public void setMessages(List<String> messages) {
        this.messages = messages;
    }

    public StatusResponse withMessages(List<String> messages) {
        this.messages = messages;
        return this;
    }

    @Override
    public String toString() {
        return new ToStringBuilder(this).append("code", code).append("messages", messages).toString();
    }

    @Override
    public int hashCode() {
        return new HashCodeBuilder().append(messages).append(code).toHashCode();
    }

    @Override
    public boolean equals(Object other) {
        if (other == this) {
            return true;
        }
        if ((other instanceof StatusResponse) == false) {
            return false;
        }
        StatusResponse rhs = ((StatusResponse) other);
        return new EqualsBuilder().append(messages, rhs.messages).append(code, rhs.code).isEquals();
    }

}
